Subject: Re: How to Import a bitkeeper repo into git

From: Pete/Piet Delaney <[email-masked]>
Date: Mon, 15 Oct 2007 20:45:55 -0700

Linus Torvalds wrote:
> 
> On Mon, 15 Oct 2007, Pete/Piet Delaney wrote:
>> I imported the CVS repository to git and it worked great. Since all
>> of our other repository are in bitkeeper the management would like to
>> stick with CVS. With git apparently still being weak in the area of
>> supporting difftool on different version that seems somewhat reasonable
>> for the time being.
> 
> I can't see how bk's difftool could possibly have any relevance to the 
> "reasonable to stick with CVS" decision, but hey, I'm always surprised by 
> peoples inventiveness in rationalizing their decisions ;)
> 
> I don't know what difftool does that a simple
> 
> 	git diff -U99 | viewdiff -

Sigh, no help for git diff.

> 
> wouldn't do, but in all honesty, I don't think I ever used difftool (I 
> found the other tools in bk much more useful - eg mergetool, renametool)

Wondering if adding a file dimension to gitk might help and adding the
ability to diff different version of a file git gitk by doing something
like holding down the shift key and/or adding a new view pull down.

> 
> I don't actually know of any sane programs to view unified diffs, but you 
> can script one with little trouble. Here's a really hacky one I just came 
> up with:
> 
> 	#!/bin/sh
> 	cat "$@" > /tmp/diff
> 	grep '^[ -]' /tmp/diff > /tmp/orig
> 	grep '^[ +]' /tmp/diff > /tmp/result
> 	meld /tmp/orig /tmp/result
> 
> which fools 'meld' into showing a unified diff in a nice graphical manner.

I just download 'meld', looks interesting, I didn't know about it or
'kompare'. Linking either one into gitk would be a pleasant graphical
'bling'.

> 
> [ Quite frankly, I don't understand why tools like meld and kdiff3 can't 
>   just take the unified diff directly - they have *all* the logic, it 
>   should be trivial to do, and very useful to view diffs for those people 
>   who like that graphical bling. ]
> 
>> The folks at bitmover are converting you kernels to bk and it's
>> maintaining the branch history and I'd like to do the same. So far
>> they haven't help us convert the git repository to bk. Do you happen
>> to know of someone else that might now how to do this in case the
>> folks at bitmover can't provide the scripts to convert this git
>> repository to bk?
> 
> Hmm. Converting from git to bk should not be that hard at least 
> conceptually, but no, I have no idea how to script it sanely and 
> efficiently. The obvious solutions all would want to have multiple active 
> heads of development open at the same time (Larry calls them "LOD's" not 
> branches), and would also require some way to set the result of a merge. 
> Neither of which I would know how to do in BK (I created a lot of merges 
> in BK, but I always let BK do the merging - I wouldn't know how to specify 
> the merge result by hand).

Hmm, actually I'm only seeing rev topology up to 2.6.13,
later version seem to be linear and when I try to use a larger
time window something seems to crashing, the gui goes away,
and 'bk revtool' returns. Sigh.

I'll try keeping it real simple and just import our release branch
and hope for the best. Hopefully Johnannes, or perhaps folks more
involved with gitk can add a bit more graphical bling soon to the
cheetah release. BTW, is this the right mailing list for discussing
gitk as well as git?

- -piet

> 
> 		Linus
> -
> To unsubscribe from this list: send the line "unsubscribe git" in
> the body of a message to [email-masked]
> More majordomo info at  http://vger.kernel.org/majordomo-info.html
>